{% extends 'core/base_bs.html' %}
{% load i18n static %}

{% block page_title %}
    <title>{{ service.project_name }} - Set your location</title>
{% endblock %}

{% block head_style %}
    {{ block.super }}
    <link rel="stylesheet" href="{% static 'pinsview/css/map.css' %}">
    <style>
        #map {height: 100%;}
        html, body {height: 100%;margin: 0;padding: 0;}
    </style>
{% endblock %}

{% block header %}{% endblock %}

{% block content %}
    <div id="map"></div>
    <form id="set-location" class="mobile-adjust" method="post" style="font-size: 1.2vw">{% csrf_token %}
        <input id="latitude" type="hidden" name="latitude">
        <input id="longitude" type="hidden" name="longitude">
        <input id="formatted-address" type="hidden" name="formatted_address">
        <input id="country-iso2" type="hidden" name="country_iso2">
        <input id="next" type="hidden" name="next" value="{{ request.META.HTTP_REFERER }}">
    </form>

    <div id="pin-location" style="display: none">
        <div class="content-string">
            <h4 class="title text-center" style="margin-top: 0; padding-bottom: 0.5vh;"></h4>
        </div>
    </div>
{% endblock %}

{% block footer %}{% endblock %}

{% block js %}
    {{ block.super }}
    <script>
        let map, infoWindow, marker, pos, here, hereMarker;
        let IKWEN = { lat: 3.834418, lng: 11.4849073 };
        function initMap() {
            map = new google.maps.Map(document.getElementById('map'), {
                center: IKWEN,
                zoom: 16,
            });
            detectCurrentLocation();
            function showNearestSpots(position) {
                here = {
                    lat: position.coords.latitude,
                    lng: position.coords.longitude
                };
                let geocoder = new google.maps.Geocoder;
                resolveLocation(geocoder, here);

                hereMarker = new google.maps.Marker({
                    position: here,
                    map: map,
                    draggable:false,
                    animation: google.maps.Animation.BOUNCE,
                    title: 'Here you are'
                });
                hereMarker.addListener('click', function() {
                    hereMarker.setAnimation(google.maps.Animation.DROP);
                    hereInfoWindow.open(map, hereMarker);
                });
                if (map.getZoom() < 18) map.setZoom(18);
                map.setCenter(here);
            };

            function notifyLocationDetectionFailure(error) {
                let img = "{% static 'pinsview/img/gps.jpg' %}",
                    message = "{% trans 'Please activate GPS and refresh the page for your location to be detected' %}",
                    title = "{% trans 'Activate your GPS' %}",
                    {#href = "javascript:location.reload(true)";#}
                    href = "javascript:window.history.back()";
                ikwen.showNoticeDialog(img, title, message, href);
            }

            let hereInfoWindow;

            function resolveLocation(geocoder, latlng){
                geocoder.geocode({'location': latlng}, function(results, status) {
                    let formattedAddress = 'Unnamed road', addressComponents = results[0].address_components;
                    console.log(results);
                    if (status === google.maps.GeocoderStatus.OK) {
                        if (results[1]) {
                            if (results[0].formatted_address.indexOf("Unnamed Road") !== -1) {
                                formattedAddress = results[1].formatted_address;
                            } else {
                                formattedAddress = results[0].formatted_address;
                            }
                        } else if (results[0]) {
                            formattedAddress = results[0].formatted_address;
                        }
                    }
                    $('#formatted-address').val(formattedAddress);
                    let countryISO2 = addressComponents[addressComponents.length - 1].short_name;
                    if (countryISO2.length > 2)
                        addressComponents = results[3].address_components;
                        countryISO2 = addressComponents[addressComponents.length - 1].short_name;
                        if (countryISO2.length > 2)
                            countryISO2 = 'CM'
                    $('#country-iso2').val(countryISO2);
                    {#if (addressComponents.length > 3)#}
                    {#    $('#administrative-area-level-2').val(addressComponents[addressComponents.length - 3].short_name);#}
                    $('#pin-location .title').text(formattedAddress);
                    let pinHereHTMLContent = $('#pin-location').html();
                    hereInfoWindow = new google.maps.InfoWindow({content: pinHereHTMLContent});
                    hereInfoWindow.open(map, hereMarker);
                });
            }
            function detectCurrentLocation() {
                if (navigator.geolocation) {
                    navigator.geolocation.getCurrentPosition(showNearestSpots, notifyLocationDetectionFailure);
                } else {
                    // handleLocationError
                    ikwen.showFloatingNotice("{% trans 'Unable to pin your position, try again!'%}", '', 4);
                }
            }
            let next = $('#next').val();
            if ( next !== ''){
                localStorage.setItem('next', next);
            } else {
                $('#next').val(localStorage.getItem('next'));
            }

        }

        function handleLocationError(browserHasGeolocation, infoWindow, pos) {
            infoWindow.setPosition(pos);
            infoWindow.setContent(browserHasGeolocation ?
                      "Error: The Geolocation service failed." :
                      "Error: Your browser doesn't support geolocation.");
            infoWindow.open(map);
        }

        function redirect(){
            window.location.replace("{{ request.GET.next }}");
        }

        $(document.body).on('click', '.set-position', function () {
            $('#latitude').val(here['lat']);
            $('#longitude').val(here['lng']);
            let savedLocation = {
              "Latitude": $('input[name=latitude]').val(),
              "Longitude": $('input[name=longitude]').val()
            };
            let savedFormattedAddress = $('input[name=formatted_address]').val();
            localStorage.setItem('Location', JSON.stringify(savedLocation));
            localStorage.setItem('FormattedAddress', savedFormattedAddress);
            ikwen.showFloatingNotice("{% trans 'Location saved successfully!'%}", '', 3);
            $('#set-location').submit();
        });
    </script>
    <script async defer
            src="https://maps.googleapis.com/maps/api/js?key=AIzaSyC47LQjTQnn98bTCgFgOW8PHUcBKIYcR08&callback=initMap">
    </script>
{% endblock %}